SystemOrganization addCategory: #'ICU-Core'!

SharedPool subclass: #ICUConstants
	instanceVariableNames: ''
	classVariableNames: 'UCAL_DATE UCAL_DAY_OF_YEAR UCAL_DST_OFFSET UCAL_ERA UCAL_MONTH UCAL_WEEK_OF_MONTH UCAL_WEEK_OF_YEAR UCAL_YEAR UCAL_ZONE_OFFSET'
	poolDictionaries: ''
	category: 'ICU-Core'!

!ICUConstants class methodsFor: 'initialization' stamp: 'jvds 6/13/2011 21:12'!
initialize

	self initializeCalendarConstants ! !

!ICUConstants class methodsFor: 'initialization' stamp: 'jvds 6/13/2011 21:24'!
initializeCalendarConstants

	UCAL_ERA := 0.
	UCAL_YEAR := 1.
	UCAL_MONTH := 2.
	UCAL_WEEK_OF_YEAR := 3.
	UCAL_WEEK_OF_MONTH := 4.
	UCAL_DATE := 5.
	UCAL_DAY_OF_YEAR := 6.
	
	UCAL_ZONE_OFFSET := 15.
	UCAL_DST_OFFSET := 16
! !

!String methodsFor: '*icu-core' stamp: 'JanVanDeSandt 2/21/2012 22:43'!
asUTF16Bytes

	^ self asUTF16String bytes! !

!String methodsFor: '*icu-core' stamp: 'JanVanDeSandt 2/21/2012 22:18'!
asUTF16String 

	| ustring |
	
	self isTwoByteString
		ifTrue: [ ^ self ].

	ustring := TwoByteString new: self size.
	self withIndexDo: [ :char :index | ustring at: index put: char ].
	^ustring! !

!String methodsFor: '*icu-core' stamp: 'JanVanDeSandt 2/21/2012 22:18'!
isTwoByteString

	^ false! !

String subclass: #TwoByteString
	instanceVariableNames: 'bytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-Core'!

!TwoByteString class methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 2/21/2012 22:02'!
fromByteArray: aByteArray 

	aByteArray size \\ 2 = 0 ifFalse: [^ ByteString fromByteArray: aByteArray ].
	^ self basicNew setBytes: aByteArray! !

!TwoByteString class methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 2/21/2012 22:10'!
fromByteArray: aByteArray charSize: anInteger

	aByteArray size = (anInteger*2)
		ifTrue: [ ^ self fromByteArray: aByteArray ].
		
	^self basicNew setBytes: (aByteArray copyFrom: 1 to: anInteger*2)! !

!TwoByteString class methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 2/21/2012 21:56'!
new: aSize

	^ self basicNew setBytes: (ByteArray new: aSize * 2)! !

!TwoByteString methodsFor: 'accessing' stamp: 'JanVanDeSandt 2/21/2012 21:52'!
at: index

	^ Character value: (bytes at: index*2 - 1) + ((bytes at: index*2) << 8)! !

!TwoByteString methodsFor: 'accessing' stamp: 'JanVanDeSandt 2/21/2012 21:59'!
at: index put: aCharacter

	bytes at: (index*2 - 1) put: aCharacter asInteger \\ 256.
	bytes at: (index*2) put: aCharacter asInteger >> 8.
	
	^ aCharacter! !

!TwoByteString methodsFor: 'accessing' stamp: 'JanVanDeSandt 2/21/2012 22:44'!
bytes

	^ bytes! !

!TwoByteString methodsFor: 'testing' stamp: 'JanVanDeSandt 2/21/2012 22:19'!
isTwoByteString

	^ true! !

!TwoByteString methodsFor: 'initialize-release' stamp: 'JanVanDeSandt 2/21/2012 21:46'!
setBytes: aByteArray

	bytes := aByteArray! !

!TwoByteString methodsFor: 'accessing' stamp: 'JanVanDeSandt 2/21/2012 21:47'!
size

	^ bytes size / 2! !
ICUConstants initialize!
